var fs     = require('fs'),
    crypto = require('crypto'),
    utils  = require('stylus').utils;
module.exports = function(url, options) {
  // Skips absolute urls.
  if (url.protocol) {
    return null;
  }

  var path = utils.lookup(url.pathname, options.paths);
  // Skips missing files.
  if(!path) {
    return null;
  }
  var contents = fs.readFileSync(path, 'utf-8');
  return crypto.createHash('md5').update(contents).digest('hex');
};