var fs    = require('fs'),
    utils = require('stylus').utils;

module.exports = function(url, options) {
  // Skips absolute urls.
  if (url.protocol) {
    return null;
  }

  var path = utils.lookup(url.pathname, options.paths);
  // Skips missing files.
  if(!path) {
    return null;
  }

  var stats = fs.statSync(path);
  return Date.parse(stats.mtime).toString();
};