var stylus     = require('stylus'),
    nodes      = stylus.nodes,
    parse      = require('url').parse,
    extname    = require('path').extname,
    basename   = require('path').basename,
    strategies = require('./strategies');

module.exports = function(options) {
  var strategy = strategies[options.strategy];

  function rename(url, fingerprint) {
    pathname  = basename(url.pathname);
    extension = extname(url.pathname);
    filename  = pathname.replace(extension, '');
    replaced  = [filename, '-', fingerprint, extension].join('');

    return url.href.replace(pathname, replaced);
  }

  function format(url) {
    return new nodes.Literal('url("' + url + '")');
  }

  function plugin(url) {

    url = parse(url.toString());

    var fingerprint = strategy(url, options);
    var literal = url.href;

    if(!fingerprint) {
      return format(literal);
    }

    if(options.rename) {
      literal = rename(url, fingerprint);
    } else {
      literal = [literal, fingerprint].join('?');
    }

    return format(literal);
  };

  return plugin;
};